Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_EC_Sched_Filter Class Reference

Decorate a filter with scheduling information. More...

`#include <EC_Sched_Filter.h>`

Inheritance diagram for TAO_EC_Sched_Filter:

[legend]
Collaboration diagram for TAO_EC_Sched_Filter:

[legend]
List of all members.

## Public Methods
| TAO_EC_Sched_Filter (const char *name, RtecScheduler::handle_t rt_info, RtecScheduler::Scheduler_ptr scheduler, TAO_EC_Filter *body, RtecScheduler::handle_t body_info, RtecScheduler::handle_t parent_info, RtecScheduler::Info_Type_t info_type)
| Constructor. More...
virtual | ~TAO_EC_Sched_Filter (void)
| Destructor. More...
virtual ChildrenIterator | begin (void) const
| STL-like iterators Filters follow the Composite pattern. More...
virtual ChildrenIterator | end (void) const
virtual int | size (void) const
virtual int | filter (const RtecEventComm::EventSet &event, TAO_EC_QOS_Info &qos_info ACE_ENV_ARG_DECL)
| Filter this event, returns 1 if the event is accepted, 0 otherwise. More...
virtual int | filter_nocopy (RtecEventComm::EventSet &event, TAO_EC_QOS_Info &qos_info ACE_ENV_ARG_DECL)
virtual void | push (const RtecEventComm::EventSet &event, TAO_EC_QOS_Info &qos_info ACE_ENV_ARG_DECL)
| This is called by the children when they accept an event and which to pass it up. More...
virtual void | push_nocopy (RtecEventComm::EventSet &event, TAO_EC_QOS_Info &qos_info ACE_ENV_ARG_DECL)
virtual void | clear (void)
| Clear any saved state, must reset and assume no events have been received. More...
virtual CORBA::ULong | max_event_size (void) const
| Returns the maximum size of the events pushed by this filter. More...
virtual int | can_match (const RtecEventComm::EventHeader &header) const
| Returns 0 if an event with that header could never be accepted. More...
virtual int | add_dependencies (const RtecEventComm::EventHeader &header, const TAO_EC_QOS_Info &qos_info ACE_ENV_ARG_DECL)
| This is used for computing the scheduling dependencies:. More...
virtual void | get_qos_info (TAO_EC_QOS_Info &qos_info ACE_ENV_ARG_DECL)
| Obtain the QOS information for this filter, the default implementation returns an invalid QOS. More...
## Private Methods
| ACE_UNIMPLEMENTED_FUNC (TAO_EC_Sched_Filter(const TAO_EC_Sched_Filter &)) ACE_UNIMPLEMENTED_FUNC(TAO_EC_Sched_Filter &operator=(const TAO_EC_Sched_Filter &)) void init_rt_info(ACE_ENV_SINGLE_ARG_DECL)
| Initialize our RT_Info handle and dependencies. More...
void | compute_qos_info (TAO_EC_QOS_Info &qos_info ACE_ENV_ARG_DECL)
| Compute a new qos_info to push up. More...
## Private Attributes
RtecScheduler::handle_t | rt_info_
| The RT_Info handle for this object. More...
int | rt_info_computed_
| Has the Scheduler been updated? More...
ACE_CString | name_
| Our operation name. More...
RtecScheduler::Scheduler_var | scheduler_
| The scheduler we are going to use. More...
TAO_EC_Filter * | body_
| The implementation. More...
RtecScheduler::handle_t | body_info_
| The RT_Info handle for the body. More...
RtecScheduler::handle_t | parent_info_
| The RT_Info handle for the parent. More...
RtecScheduler::Info_Type_t | info_type_
| Required for the scheduling service. More...

## Detailed Description

Decorate a filter with scheduling information.

This filter decorates a regular filter with scheduling information. It creates a new RT_Info entry for the filter and it adds the dependencies between the filter and any childrens it may have.

## Memory Management

It assumes ownership of the children.

## Constructor & Destructor Documentation

TAO_EC_Sched_Filter::TAO_EC_Sched_Filter | ( | const char * | name,
|  | RtecScheduler::handle_t | rt_info,
|  | RtecScheduler::Scheduler_ptr | scheduler,
|  | TAO_EC_Filter * | body,
|  | RtecScheduler::handle_t | body_info,
|  | RtecScheduler::handle_t | parent_info,
|  | RtecScheduler::Info_Type_t | info_type
| ) |

| Constructor. It assumes ownership of the , makes a copy of the other parameters

TAO_EC_Sched_Filter::~TAO_EC_Sched_Filter | ( | void |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

TAO_EC_Sched_Filter::ACE_UNIMPLEMENTED_FUNC | ( | TAO_EC_Sched_Filter(const TAO_EC_Sched_Filter &) |  | ) | const`[private]`

| Initialize our RT_Info handle and dependencies.

int TAO_EC_Sched_Filter::add_dependencies | ( | const RtecEventComm::EventHeader & | header,
|  | const TAO_EC_QOS_Info &qos_info | ACE_ENV_ARG_DECL
| ) | `[virtual]`

| This is used for computing the scheduling dependencies:. Leaf filters check if the header could be matched, similar to the can_match() method; if it does they return 1, and 0 otherwise. Intermediate nodes always return 0. This is used to build precise dependencies between the suppliers and the leaf of the filters that accept that event. Notice that only the nodes doing scheduling recurse through the list, so in configurations that do no require scheduling the recursion stops fairly soon. Reimplemented from TAO_EC_Filter.

TAO_EC_Filter::ChildrenIterator TAO_EC_Sched_Filter::begin | ( | void |  | ) | const`[virtual]`

| STL-like iterators Filters follow the Composite pattern. All filters expose the same interface as if they all had children, but for simple filters the iterators return an empty range. Reimplemented from TAO_EC_Filter.

int TAO_EC_Sched_Filter::can_match | ( | const RtecEventComm::EventHeader & | header | ) | const`[virtual]`

| Returns 0 if an event with that header could never be accepted. This can used by the suppliers to filter out consumers that couldn't possibly be interested in their events. The rt_info and Reimplemented from TAO_EC_Filter.

void TAO_EC_Sched_Filter::clear | ( | void |  | ) | `[virtual]`

| Clear any saved state, must reset and assume no events have been received. Reimplemented from TAO_EC_Filter.

void TAO_EC_Sched_Filter::compute_qos_info | ( | TAO_EC_QOS_Info &qos_info | ACE_ENV_ARG_DECL | ) | `[private]`

| Compute a new qos_info to push up.

TAO_EC_Filter::ChildrenIterator TAO_EC_Sched_Filter::end | ( | void |  | ) | const`[virtual]`

| Reimplemented from TAO_EC_Filter.

int TAO_EC_Sched_Filter::filter | ( | const RtecEventComm::EventSet & | event,
|  | TAO_EC_QOS_Info &qos_info | ACE_ENV_ARG_DECL
| ) | `[virtual]`

| Filter this event, returns 1 if the event is accepted, 0 otherwise. Notice that there are two versions of the method, if the event is not const then filter can take ownership of the event. Reimplemented from TAO_EC_Filter.

int TAO_EC_Sched_Filter::filter_nocopy | ( | RtecEventComm::EventSet & | event,
|  | TAO_EC_QOS_Info &qos_info | ACE_ENV_ARG_DECL
| ) | `[virtual]`

| Reimplemented from TAO_EC_Filter.

void TAO_EC_Sched_Filter::get_qos_info | ( | TAO_EC_QOS_Info &qos_info | ACE_ENV_ARG_DECL | ) | `[virtual]`

| Obtain the QOS information for this filter, the default implementation returns an invalid QOS. Only the filters that support scheduling information implement this method. Returns 0 on success and -1 on failure Reimplemented from TAO_EC_Filter.

CORBA::ULong TAO_EC_Sched_Filter::max_event_size | ( | void |  | ) | const`[virtual]`

| Returns the maximum size of the events pushed by this filter. Reimplemented from TAO_EC_Filter.

void TAO_EC_Sched_Filter::push | ( | const RtecEventComm::EventSet & | event,
|  | TAO_EC_QOS_Info &qos_info | ACE_ENV_ARG_DECL
| ) | `[virtual]`

| This is called by the children when they accept an event and which to pass it up. Notice that there are two versions of the method, if the event is not const then filter can take ownership of the event. Reimplemented from TAO_EC_Filter.

void TAO_EC_Sched_Filter::push_nocopy | ( | RtecEventComm::EventSet & | event,
|  | TAO_EC_QOS_Info &qos_info | ACE_ENV_ARG_DECL
| ) | `[virtual]`

| Reimplemented from TAO_EC_Filter.

int TAO_EC_Sched_Filter::size | ( | void |  | ) | const`[virtual]`

| Reimplemented from TAO_EC_Filter.

## Member Data Documentation

TAO_EC_Filter* TAO_EC_Sched_Filter::body_`[private]`

| The implementation.

RtecScheduler::handle_t TAO_EC_Sched_Filter::body_info_`[private]`

| The RT_Info handle for the body.

RtecScheduler::Info_Type_t TAO_EC_Sched_Filter::info_type_`[private]`

| Required for the scheduling service.

ACE_CString TAO_EC_Sched_Filter::name_`[private]`

| Our operation name.

RtecScheduler::handle_t TAO_EC_Sched_Filter::parent_info_`[private]`

| The RT_Info handle for the parent.

RtecScheduler::handle_t TAO_EC_Sched_Filter::rt_info_`[private]`

| The RT_Info handle for this object.

int TAO_EC_Sched_Filter::rt_info_computed_`[private]`

| Has the Scheduler been updated?

RtecScheduler::Scheduler_var TAO_EC_Sched_Filter::scheduler_`[private]`

| The scheduler we are going to use.

The documentation for this class was generated from the following files:

- EC_Sched_Filter.h
- EC_Sched_Filter.cpp